#pragma once

#include <list>
#include <string>

using namespace std;

class CDriverBase
{
public:
	CDriverBase(bool bLog = false);
	virtual ~CDriverBase(void);

public:
	virtual string Read(UINT nSize = 0) = 0;
	virtual bool Read(BYTE* byRead, UINT nSize) = 0;
	virtual bool Write(string strWrite) = 0;
	virtual bool Write(BYTE* byWrite, UINT nSize) = 0;
	virtual bool Open() = 0;
	virtual void Close() = 0;
	virtual unsigned int InWaiting(void) = 0;

	virtual void SetTimeout(double dTimeout) = 0;
	virtual double GetTimeout() = 0;

	virtual void SetWriteTimeout(double nTimeout) = 0;
	virtual double GetWriteTimeout() = 0;

	string ReadLine(char cEOL = '\n', size_t nSize = 0);
	list<string> ReadLines(char cEOL = '\n', int nSizeHint = 0);
	list<string> xreadlines(int nSizeHint = 0);
	bool writelines(list<string> lstrSequence);

	void SetWriteLog(bool bLog);
	bool GetWriteLog();
	void WriteLog(string &sLog, string sTag = "Read");
	void WriteLog(BYTE* sLog, UINT nSize, string sTag = "Read");

	virtual void FlushInput(void) = 0;
	virtual bool IsOpen() = 0;

protected:
	double m_dTimeout;
	CIronLog *m_pLog;
	bool m_bLog;
	bool m_bOpen;
};
