#pragma once

#include "SerialBase.h"

class CSerial :	public CSerialBase
{
public:
	CSerial(bool bLog = false,
			unsigned nPort = 0,
			UINT nBaudrate = 9600,
			int nBytesize = EIGHTBITS,
			WORD wParity = PARITY_NONE,
			int nStopbits = STOPBITS_ONE,
			int nTimeout = -1,
			int nXOnXOff = 0,
			int nRtsCts = 0,
			int nWriteTimeout = 0,
			int nDsrDtr = 0);
	virtual ~CSerial(void);
	bool Open(void);
	void ReconfigurePort(void);
	void Close(void);
	unsigned int InWaiting(void);
	string Read(UINT nSize = 1);
	bool Read(BYTE* byRead, UINT nSize);
	bool Write(string strWrite);
	bool Write(BYTE* byWrite, UINT nSize);
	void FlushInput(void);
	void FlushOutput(void);
	void SendBreak(void);
	void SetRTS(bool bLevel = true);
	void SetDTR(bool bLevel = true);
	bool GetCTS(void);
	bool GetDSR(void);
	bool GetRI(void);
	bool GetCD(void);
	void SetXON(bool bLevel);

	bool IsOpen() { return m_bOpen; }

private:
	HANDLE m_hComPort;
	COMMTIMEOUTS m_orgTimeout;
	UINT m_dwRtsState;
	UINT m_dwDtrState;
	OVERLAPPED m_overlappedRead;
	OVERLAPPED m_overlappedWrite;
};
