#include "StdAfx.h"
#include "TCPBase.h"

const double CTCPBase::defaultTimeout = -1.0;

CTCPBase::CTCPBase(bool bLog, LPCTSTR sAddr, unsigned short nPort)
: CDriverBase(bLog)
{
	m_bOpen = false;
	m_dTimeout = defaultTimeout;

	if (bLog)
	{
		char strFilename[FILENAME_MAX];

		if( !CIronLib::ReadRegistryString(HKEY_LOCAL_MACHINE, "SOFTWARE\\IronTools\\Application\\", NULL, ".\\", strFilename, FILENAME_MAX) )
		{
			CIronLib::WriteDebugLog("ReadRegistryString() return is false.(%s:%d)", __FILE__, __LINE__);
		}

		string strInstallFolder = strFilename;
	
		if( strInstallFolder.find_last_of('\\') != strInstallFolder.size() - 1 )
		{
			strInstallFolder += "\\";
		}

		string logFile = sAddr;
		logFile += "_" + CIronLib::itostring(nPort);

		m_pLog = new CIronLog(logFile, strInstallFolder + "CommLog\\");
	}
}

CTCPBase::~CTCPBase(void)
{
}

void CTCPBase::SetTimeout(double dTimeout)
{
	if (dTimeout != -1.0 && dTimeout < 0.0)
	{
		CIronLib::WriteDebugLog("Timeout value out of range.(%s:%d)", __FILE__, __LINE__);
		return;
	}

	m_dTimeout = dTimeout;

	SetBlocking(dTimeout < 0.0);
}

double CTCPBase::GetTimeout()
{
	return m_dTimeout;
}

void CTCPBase::SetWriteTimeout(double dTimeout)
{
	if (dTimeout < 0)
		assert(false);

	m_dWriteTimeout = dTimeout;
}

double CTCPBase::GetWriteTimeout()
{
	return m_dWriteTimeout;
}