#pragma once

#include "driverbase.h"

class CTCPBase :
	public CDriverBase
{
public:
	CTCPBase(bool bLog, LPCTSTR sAddr, unsigned short nPort);
	virtual ~CTCPBase(void);
	virtual bool Open() = 0;
	virtual void Close() = 0;
	virtual unsigned int InWaiting(void) = 0;
	virtual string Read(UINT nSize = 0) = 0;
	virtual bool Read(BYTE* byRead, UINT nSize) = 0;
	virtual bool Write(string strWrite) = 0;
	virtual bool Write(BYTE* byWrite, UINT nSize) = 0;
	virtual void SetBlocking(bool block) = 0;

	void SetTimeout(double dTimeout);
	double GetTimeout();

	void SetWriteTimeout(double dTimeout);
	double GetWriteTimeout();

	virtual void FlushInput(void) = 0;
	virtual bool IsOpen() = 0;

protected:
	static const double defaultTimeout;
	double m_dTimeout;
	double m_dWriteTimeout;
};
