#pragma once

#include <windows.h>

#include <string>
#include <vector>
#include <list>
#include <map>

using namespace std;

#include "Device.h"


#define INISECTION_SIZE			1024

typedef struct _tagDeviceInfo
{
	bool bReal;
	bool bThread;
	bool bLog;
	unsigned uPollingTime;
	unsigned uPort;
	unsigned uOutput;
	int nTimeout;
	string strDriver;
	string strIOFile;
} DEVICE_INFO;

class CDeviceInfo
{
public:
	CDeviceInfo(void);
	~CDeviceInfo(void);

	bool GetDeviceInfo(map<string, DEVICE_INFO>& devices);

	CDevice* LoadDriver(string strDevice);
	void UnloadDriver(string strDevice);

	static string GetApplicationFolder();

private:
	string m_strConfigFolder;
	map<string, DEVICE_INFO> m_mDriverInfo;

	map<string, CDevice*> m_mDriver;
};
