#pragma once

#include <windows.h>
#include <time.h>
#include <sys/timeb.h>
#include <string>
#include <vector>

using namespace std;

class CIronLib
{
public:
	CIronLib(void);
	~CIronLib(void);

	static double GetTime(void);
	static bool CheckRetArray(int* array, int nArraySize);
	static bool IsArrayInt(const int* array, int nSize, int nVal);
	static void WriteDebugLog(const char *format, ...);
	static string itostring(int nVal);
	static string itostring(unsigned long nVal);
	static string itostring(double dVal);
	static vector<string> split(string &str, string sep);
	static void ReplaceHex(string &strSource);
	static BYTE ASCIItoBinary(char ch);
	static BYTE AsciiToDec(BYTE byVal);
	static int HextoDec(string sVal, bool bMinus = false);
	static string DecToHex(int nVal);
	static bool CreateDir(LPCSTR createDir);

	static UINT ReadRegistryInt(HKEY hKey, LPCTSTR lpKey, LPCTSTR lpValue, INT nDefault);
	static bool ReadRegistryString(HKEY hKey, LPCTSTR lpKey, LPCTSTR lpValue, LPCTSTR lpDefault, LPTSTR lpRet, DWORD nSize);
	static bool WriteRegistryInt(HKEY hKey, LPCTSTR lpKey, LPCTSTR lpValue, UINT nData);
	static bool WriteRegistryString(HKEY hKey, LPCTSTR lpKey, LPCTSTR lpValue, LPCTSTR lpData);
};
