#include "StdAfx.h"
#include "IronMemoryMap.h"

CIronMemoryMap::CIronMemoryMap(void)
{
	m_hMap = NULL;
	m_lpMapping = NULL;
	m_iErrorCode = ERROR_SUCCESS;
}

CIronMemoryMap::~CIronMemoryMap(void)
{
}

BOOL CIronMemoryMap::Create(PSTR pName, DWORD dwSize)
{
	m_hMap = CreateFileMapping(INVALID_HANDLE_VALUE, 0, PAGE_READWRITE, 0, dwSize, pName);
	
	if (!m_hMap) 
	{
		LPVOID lpMsgBuf;
		m_iErrorCode=GetLastError();
		FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			GetLastError(),
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
			);
		MessageBox( NULL, (LPCTSTR)lpMsgBuf, "Error", MB_OK | MB_ICONINFORMATION );
		LocalFree( lpMsgBuf );
		return FALSE;
	}

	return TRUE;
}

BOOL CIronMemoryMap::Open(PSTR pName)
{
	m_hMap = OpenFileMapping(FILE_MAP_ALL_ACCESS,FALSE,pName);

	if (!m_hMap)
	{
		LPVOID lpMsgBuf;
		m_iErrorCode=GetLastError();
		FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			GetLastError(),
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
			);
		MessageBox( NULL, (LPCTSTR)lpMsgBuf, "Error", MB_OK | MB_ICONINFORMATION );
		LocalFree( lpMsgBuf );
	
		return FALSE;
	}

	return TRUE;
}

LPVOID CIronMemoryMap::ObtainPointer()
{
	m_lpMapping = MapViewOfFile(m_hMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);

	if (!m_lpMapping)
	{
		LPVOID lpMsgBuf;
		m_iErrorCode=GetLastError();
		FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			GetLastError(),
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
			);
		MessageBox( NULL, (LPCTSTR)lpMsgBuf, "Error", MB_OK | MB_ICONINFORMATION );
		LocalFree( lpMsgBuf );
	}

	return m_lpMapping;
};

BOOL CIronMemoryMap::ReleasePointer()
{
	if( m_lpMapping == NULL )
		return FALSE;

	BOOL bResult = UnmapViewOfFile(m_lpMapping);

	if (!bResult)
	{
		m_iErrorCode=GetLastError();
		LPVOID lpMsgBuf;
		m_iErrorCode=GetLastError();
		FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			GetLastError(),
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
			);
		MessageBox( NULL, (LPCTSTR)lpMsgBuf, "Error", MB_OK | MB_ICONINFORMATION );
		LocalFree( lpMsgBuf );
	}

	return bResult;
};

BOOL CIronMemoryMap::Close()
{ 
	if( m_hMap == NULL )
		return FALSE;

	if (!CloseHandle(m_hMap))
	{
		m_iErrorCode=GetLastError();
		return FALSE;
	}

	return TRUE;
};
