#include "StdAfx.h"
#include "IronThread.h"

CIronThread::CIronThread(void)
{
	m_threadID = 0;
	m_hThread = 0;


    m_bTerminated = false;
    m_bFreeOnTerminate = false;
    m_bFinished = false;

	m_uExitCode = 0;
}

CIronThread::~CIronThread(void)
{
	if (m_threadID!=0 && m_bFinished==false)
	{
		Terminate();
		WaitFor();
	}

	if (m_hThread!=0)
		CloseHandle(m_hThread);
}

void CIronThread::WaitFor(void)
{
	WaitForSingleObject(m_hThread, INFINITE);
}

bool CIronThread::IsRunning () 
{ 
	if (m_bFinished==false && m_hThread != NULL)
		return true;
	else 
		return false;
}

bool CIronThread::BeginThread(void)
{
	if (IsRunning() == true)
		return true;

	m_hThread = (HANDLE)_beginthreadex (NULL, 0, &ThreadProc, this, 0, &m_threadID);

	if (m_hThread == 0)
	{
		m_threadID = 0;
		return false;
	}

	return true;
}

void CIronThread::Terminate(void)
{
	m_bTerminated = true;
}

unsigned __stdcall CIronThread::ThreadProc(void* PtrToInstance)
{
	bool bFreeThread;
	unsigned uRet=0;

	CIronThread *pThread = reinterpret_cast<CIronThread*>(PtrToInstance);

	if (pThread->m_bTerminated==false)
	{
		pThread->OnExecute();
	}

	bFreeThread = pThread->m_bFreeOnTerminate;
	uRet = pThread->m_uExitCode;
	pThread->m_bFinished = true;

	if(bFreeThread==true)
	{
		delete pThread;
	}

	_endthreadex(uRet);

	return uRet;
}