#pragma once

#include <windows.h>
#include <process.h>

class CIronThread
{
public:
	CIronThread(void);
	~CIronThread(void);

	bool BeginThread(void);
	void Terminate(void);
	void WaitFor(void);

	unsigned int GetThreadID () { return m_threadID; }
	unsigned int GetExitCode () { return m_uExitCode; };
	bool IsRunning ();
	bool IsTerminated() { return m_bTerminated; }
	bool IsFinished() { return m_bFinished; }

protected:
	virtual void OnExecute(void) = 0;
	static unsigned __stdcall ThreadProc (void* PtrToInstance);

public:
	bool m_bFreeOnTerminate;

protected:
	unsigned int m_threadID;
	HANDLE m_hThread;

    bool m_bTerminated;
    bool m_bFinished;

	unsigned int m_uExitCode;
};
