#pragma once

#include <Serial.h>

class CDevice:
	public CSerial,
	public CIronSynchObject
{
public:
	CDevice(void);
	CDevice(bool bLog, unsigned uPort);
	~CDevice(void);

	bool GetDeviceStatus();

	LONG GetControlMode(int& nVal);
	LONG GetCloseOpen(int& nVal);
	LONG GetThrottleStatus(int& nVal);
	LONG GetPressure(double& dVal);
	LONG GetPosition(double& dVal);

	LONG SetPressure(double dVal);
	LONG SetPosition(double dVal);
	LONG SetControlMode(int nVal);
	LONG SetCloseOpen(int nVal);

/*	LONG WriteSelectSetPoint(int nVal);
	LONG WriteSensorRange(int nVal);
	LONG WritePressureUnit(int nVal);
	LONG WriteSensorVolRange(int nVal);
	LONG WriteCloseOpen(int nVal;

	LONG WriteSetPointA(double dVal);
	LONG WriteSetPointB(double dVal);
	LONG WriteSetPointC(double dVal);
	LONG WriteSetPointD(double dVal);
	LONG WriteSetPointE(double dVal);
	LONG WriteAnalogSetPoint(double dVal);*/

private:
	int m_nAccessMode;
	int m_nCloseOpen;
	int m_nThrottleStatus;
	double m_dPressure;
	double m_dPosition;
	int m_nPressureControlStatus;
};
