#pragma once

#include <Serial.h>

const int MAX_STAGE = 10;
const int MAX_SLOT = 20;

class CDevice:
	public CSerial,
	public CIronSynchObject,
	public CIronThread
{
public:
	CDevice(void);
	CDevice(bool bLog, unsigned uPort);
	~CDevice(void);

private:
	string MakeCheckSum(string strData);
	
public:
	LONG GetError(int& nVal);
	LONG GetFlag9(int& nVal);
	LONG GetFlag10(int& nVal);
	LONG GetOriginComplete(int& nVal);
	LONG GetStopComplete(int& nVal);
	LONG GetResetComplete(int& nVal);
	LONG GetGetReadyComplete(int& nVal);
	LONG GetPutReadyComplete(int& nVal);
	LONG GetGetUpDownComplete(int& nVal);
	LONG GetPutUpDownComplete(int& nVal);
	LONG GetGetComplete(int& nVal);
	LONG GetPutComplete(int& nVal);
	LONG GetGripComplete(int& nVal);
	LONG GetRetractComplete(int& nVal);
	LONG GetExtractComplete(int& nVal);
	LONG GetHomeComplete(int& nVal);
	LONG GetMapComplete(int& nVal);
	LONG GetMapDataComplete(int& nVal);
	LONG GetMapData(string& strVal);

	LONG SetStage(int nVal);
	LONG SetSlot(int nVal);
	LONG SetArm(int nVal);
	LONG SetExtractMode(int nVal);
	LONG SetOrigin(int nVal);
	LONG SetStop(int nVal);
	LONG SetReset(int nVal);
	LONG SetGetReady(int nVal);
	LONG SetPutReady(int nVal);
	LONG SetGetUpDown(int nVal);
	LONG SetPutUpDown(int nVal);
	LONG SetGet(int nVal);
	LONG SetPut(int nVal);
	LONG SetGrip(int nVal);
	LONG SetRetract(int nVal);
	LONG SetExtract(int nVal);
	LONG SetHome(int nVal);
	LONG SetMap(int nVal);
	LONG SetMapData(int nVal);

private:
	void OnExecute(void);

	void CheckRecieveData(string& strRead);

private:
	HANDLE m_hStopEvent;

	string m_strStage;
	string m_strSlot;
	string m_strArm;
	string m_strExtractMode;
	string m_strMapData;

	int m_nError;
	int m_nFlag9;
	int m_nFlag10;
	int m_nOriginComplete;
	int m_nStopComplete;
	int m_nResetComplete;
	int m_nGetReadyComplete;
	int m_nPutReadyComplete;
	int m_nGetUpDownComplete;
	int m_nPutUpDownComplete;
	int m_nGetComplete;
	int m_nPutComplete;
	int m_nGripComplete;
	int m_nRetractComplete;
	int m_nExtractComplete;
	int m_nHomeComplete;
	int m_nMapComplete;
	int m_nMapDataComplete;
};
