#pragma once

#include <TcAdsDef.h>
#include <TcAdsAPI.h>

#pragma comment(lib, "TcAdsDll.lib")

#include <map>

using namespace std;

enum DeviceType { NONE, VOL_0_10, CUR_4_20 };

static map<string, void*> m_mVariable;
static map<ULONG, string> m_mNotification;

class CDevice:
	public CIronSynchObject,
	public CIronThread
{
public:
	CDevice(void);
	CDevice(bool bLog,
		bool bThread ,
		unsigned char* netId,
		unsigned uPort,
		int nDISize,
		int nDIOffset,
		int nDOSize,
		int nDOOffset,
		int nAISize,
		int nAIOffset,
		int nAOSize,
		int nAOOffset);
	~CDevice(void);

	bool GetDI(unsigned uAddr, unsigned uIndex, int &nData);
	bool GetDO(unsigned uAddr, unsigned uIndex, int &nData);
	
	bool GetAI(unsigned uAddr, unsigned uIndex, double &dData, int nType = NONE);
	bool GetAO(unsigned uAddr, unsigned uIndex, double &dData, int nType = NONE);
	
	bool SetDO(unsigned uAddr, unsigned uIndex, int nData); 
	bool SetAO(unsigned uAddr, unsigned uIndex, double dData, int nType = NONE);

	bool GetVariable(LPTSTR varName, unsigned varSiz, unsigned uSize, void* pData, bool bEvent);
	bool SetVariable(LPTSTR varName, unsigned varSiz, unsigned uSize, void* pData);

	static void __stdcall Callback(AmsAddr* pAddr, AdsNotificationHeader* pNotification, ULONG hUser);

private:
	void Open(unsigned uPort, unsigned char* netId);
	void OnExecute(void);
	double DataToVol(WORD nVal);
	WORD VolToData(double dVal);
	double DataToCurrent(WORD nVal);
	WORD CurrentToData(double dVal);

private:
	bool m_bThread;

	CIronLog *m_pLog;
	HANDLE m_hStopEvent;

	LONG m_nErr;
	LONG m_nPort;
	AmsAddr m_Addr;
	PAmsAddr  m_pAddr;

	BYTE *m_pDIBuffer;
	BYTE *m_pDOBuffer;
	WORD *m_pAIBuffer;
	WORD *m_pAOBuffer;

	int m_nDIOffset;
	int m_nDOOffset;
	int m_nAIOffset;
	int m_nAOOffset;

	int m_nDISize;
	int m_nDOSize;
	int m_nAISize;
	int m_nAOSize;

	LONG m_nPrevGetErr;
	LONG m_nPrevSetErr;

	map<string, ULONG> m_mHandle;
};
