#pragma once

#include <Serial.h>

enum ACK { ST, BU, OK, ER, None };

class CDevice:
	public CSerial,
	public CIronSynchObject,
	public CIronThread
{
public:
	CDevice(void);
	CDevice(bool bLog, unsigned uPort);
	~CDevice(void);
	
private:
	void OnExecute();
	ACK CheckNotification(string strRead);
	ACK CheckAck(string strRead);

public:
	bool GetWaferCenterInformation();

	LONG GetAngleOffset(double& dVal);
	LONG GetAngle(double& dVal);

	LONG GetChuckPosition(int& nVal);
	LONG GetErrorStatus(int& nVal);
	LONG GetSystemSetting(int& nVal);
	LONG GetSystemStatus(int& nVal);
	LONG GetVacuum(int& nVal);
	LONG GetWaferCenter(void);
	LONG GetWaferSize(int& nVal);
	LONG GetWaferExistence(int& nVal);
	LONG GetComplete(int& nVal);

	
	LONG SetAngleOffset(double dVal);
	LONG SetAngle(double dVal);

	LONG SetChuckUpDown(int nVal);
	LONG SetErrorClear(int nVal);
	LONG SetRunCalibration(int nVal);
	LONG SetReset(int nVal);
	LONG SetInitialize(int nVal);
	LONG SetRotateWafer(int nVal);
	LONG SetSystemSetting(int nVal);
	LONG SetStartAlignment(int nVal);
	LONG SetVacuum(int nVal);
	LONG SetWaferSize(int nVal);
	LONG SetCheckWaferExistence(int nVal);

private:
	HANDLE m_hStopEvent;

	double m_dAngle;

	int m_nWaferExistence;
	int m_nComplete;	
};
